'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = require("fs");

var _path = require("path");

class I18n {
  constructor(messages) {
    this._path = (0, _path.join)(__dirname, '../i18n');
    this._userMessages = messages || {};
    this.setLocale('en');
  }

  setLocale(locale) {
    if (!locale || this._locale === locale) return;
    const temp = this._userMessages[locale] || this._userMessages['*'] || {};
    const file = (0, _path.join)(this._path, locale + '.json');

    if ((0, _fs.existsSync)(file)) {
      this._locale = locale;
      this._messages = Object.assign(require(file), temp);
    } else {
      this._locale = 'en';
      this._messages = Object.assign({}, temp);
    }
  }

  message(key) {
    return this._messages[key] || key;
  }

}

exports.default = I18n;
module.exports = exports.default;