'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _nodemailer = _interopRequireDefault(require("nodemailer"));

var _lodash = _interopRequireDefault(require("lodash.template"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(app, options = {}) {
  const templates = options.templates || {};

  const transport = _nodemailer.default.createTransport(options);

  Object.keys(templates).forEach(k => {
    templates[k].title = (0, _lodash.default)(templates[k].subject, {
      interpolate: /{{([\s\S]+?)}}/g
    });
    templates[k].render = (0, _lodash.default)(templates[k].html, {
      interpolate: /{{([\s\S]+?)}}/g
    });
  });
  app.use(async function mailHandler(ctx, next) {
    ctx.sendMail = (to, tplName, context, attachments = null) => {
      const tpl = templates[tplName];
      return transport.sendMail({
        from: options.from,
        to: to,
        attachments: attachments,
        subject: tpl.title(context),
        html: tpl.render(context)
      });
    };

    await next();
  });
}

module.exports = exports.default;